
hirom

;org $C80FE6 ;hardcore mute (bugs)
;db $2F

org $C8094A; changing music
JSL playMsu
NOP
NOP

org $C8142d
db $00,$00

; Conn----------- hooks
;org $C08423; accelerate music
;JSL accel
;NOP

org $C0CDF8 ;accelerate music at 70%
JSL seventy


org $C3F85C
JSL pauseStart
NOP

org $C3F752
JSL pauseEnd
NOP

org $C0CEDD
JSL fightEnd ;mute at fight ends
NOP


org $C808D0
JSL mute
NOP

org $C80913
JSL roundEnd
NOP

org $C081A7
JSL nmi
NOP
NOP

org $C8096C
JSL muteBlack
NOP
NOP

org $C0F050
JSL throw
;---------------



org $C0F7A0
playMsu:
PHA
PHP ;save processor status
SEP #$20
TXA
CMP #$4F
BNE $04
JSL fhintro
STA $7ffd00
PLP ;restore processor status
PLA
STA $2140
STA $2141
RTL	

fhintro:
LDA $E7
cmp #$00
Bne $03
LDA #$00
RTL
LDA #$4F
RTL

msuRoutine:
PHA
LDA #$00
STA $002006
PLA
PHA
STA $002004
STA $7ffd00
LDA #$00
STA $002005
STA $7ffd02
loop:
lda $002000
AND #$40
BNE loop
lda $002000
AND #$08
BNE noTrack ; error bit set?
PLA
cmp #$65
BEQ noloop
cmp #$af
BEQ noloop
cmp #$ca
BEQ noloop
cmp #$e6
BEQ noloop
LDA #$03
BRA endroutine
noloop:
LDA #$01
endroutine:
STA $002007
LDA #$ff
STA $002006
STA $7ffd03
RTL
noTrack:
PLA
RTL

;--------------------Conn
accel:
LDA #$F7
STA $2140
LDA $7ffd00
CLC
ADC #$01
JSL msuRoutine
RTL

seventy:
PHA
SEC 
SBC $58,x
CMP #$70
BCC msu30
PLA
SEC
SBC $58,x
STA $56,x
RTL
msu30:
LDA $7ffd01
CMP #$01
BEQ noacc
LDA #$01
STA $7ffd01
LDA $7ffd00
CLC
ADC #$01
cmp #$E6
BNE $03
CLC
ADC #$01 ;clown stage acc=E7
JSL msuRoutine
noacc:
PLA
SEC
SBC $58,x
STA $56,x
RTL


pauseStart:
LDA #$07
STA $0917
LDA #$00
STA $002007
RTL

pauseEnd:
LDA #$03
STA $002007
LDA #$00
STA $0917
RTL

fightEnd:
LDA #$08
STA $2143
LDA #$01
STA $7ffd02
RTL

mute:
cmp #$07
BEQ playTrack
CMP #$F3
BNE $08
LDA #$01
STA $7ffd02
LDA #$f3
STA $2140
STA $E8
RTL
playTrack:
LDA #$F4
STA $2140
STA $E8
LDA $7ffd00 ; play track
JSL msuRoutine
RTL

roundEnd:
LDA #$F0
STA $2140
LDA #$01
STA $7ffd02
LDA #$00
STA $7ffd01
RTL

nmi:
LDA $4210
STZ $420B
LDA $7ffd02
BNE $01
RTL
lda $7ffd03
CMP #$00
BEQ endslow
dec
dec
dec
cmp #$10
bcs $06
endslow:
lda #$00
sta $7ffd02 ;erase fade flag
sta $002006
sta $7ffd03
RTL

muteBlack:
STA $2140
STA $2141
LDA #$00
STA $002006
STA $7ffd02
RTL

throw:
STA $7ffd02
JSL $C80004
RTL